'''
Created on Mar 12, 2011

@author: andenixa
'''

class Packer:
    def __init__(self):
        pass
    
    def pack_int(self, obj):
        return "i%d" % obj
    
    def pack_str(self, obj):
        return "S%d:%s" % (len(obj), obj)   
    
    def pack_long(self, obj):
        return "i%d" % obj
    
    def pack_Exception(self, obj):
        packed_str = "e1:%s%s" % (self.pack("errortext"), self.pack(str(obj)) )
        return packed_str    
    
    def pack_list(self, obj):
        packed_str = "a%d:" % len(obj)
        
        for object in obj:
            packed_str+=self.pack(object)
            
        return packed_str
        
    def pack_dict(self, obj):             
        
        packed_str = "d%d:" % len(obj.keys());
         
        for key in obj.keys():
            packed_str+=self.pack(key)
            packed_str+=self.pack(obj[key])
        
        return packed_str
    
    def pack_tuple(self, obj):
        packed_str = "a%d:" % len(obj)
        
        for object in obj:
            packed_str+=self.pack(object)
            
        return packed_str
    
    def pack(self, obj):                        
        
        try:
            pack_func = getattr(self, "pack_"+type(obj).__name__)
        except:
            raise Exception("Don't know how to pack type '%s'" % type(obj).__name__)
        
        return pack_func(obj)
                

if __name__=="__main__":
    pk = Packer()    
    print( pk.pack(Exception("dsdsdsd")) )