'''
Created on Mar 12, 2011

@author: andenixa
'''

class Unpacker:
    def __init__(self):
        pass
    
    def unpack(self, packed_str):
        self.packed_str = packed_str
        return self.__unpack_next()
    
    def  __unpack_next(self):
        type_s = self.packed_str[0]
        
        try:
            unpack_func = getattr(self, "unpack_"+type_s)
        except:            
            raise Exception("Unknown type '%s', (packet str: %s)" % (type_s, self.packed_str ))
                    
        return unpack_func()          
    
    def unpack_i(self):
        self.packed_str = self.packed_str[1:]                
        
        s_int = ""  
        
        for n in range(len(self.packed_str)):
            if( self.packed_str[n].isdigit()):
                s_int +=self.packed_str[n]
            elif self.packed_str[n]=='-':
                s_int +=self.packed_str[n]
            else:
                break
            
        self.packed_str = self.packed_str[len(s_int):]            
            
        return int(s_int) 
    
    def unpack_s(self):        
        self.packed_str = self.packed_str[1:]
        retval = self.packed_str
        self.packed_str = self.packed_str[len(retval):]
        return retval
        
    def unpack_S(self):
        self.packed_str = self.packed_str[1:] 
        num_chars = self.packed_str.split(":")[0]      
        self.packed_str = self.packed_str[self.packed_str.find(":")+1:]
        retval = self.packed_str[:int(num_chars)]
        self.packed_str = self.packed_str[len(retval):]         
        return retval        
    
    def unpack_a(self):
        #remove the type_name char
        self.packed_str = self.packed_str[1:]
        list_len = self.packed_str.split(":")[0]
        #remove length identifier
        self.packed_str = self.packed_str[self.packed_str.find(":")+1:]
        
        t = []
        
        for i in range(int(list_len)):
            t.append(self.__unpack_next())
            
        return t
    
    def unpack_t(self):
        self.packed_str = self.packed_str[1:]
        num_members = self.packed_str.split(":")[0]
        self.packed_str = self.packed_str[self.packed_str.find(":")+1:]
        
        t = {}
        
        for i in range(int(num_members)):
            member_name = self.__unpack_next()
            membee_value = self.__unpack_next()
            t[member_name] = membee_value 
            
        return t        

if __name__=="__main__":
    up = Unpacker()
    print(up.unpack('i-111'))        
    ##print( up.unpack('i1187') )
