use uo;
use os;

const PROPID_MYSQL_AUX_PIDS := "#mysql_aux_pids";

const MYSQL_QUERY_TIMEOUT := 30;// seconds

function SQLQuery( s_query, blocking := 1 )

    var pids := GetGlobalProperty( PROPID_MYSQL_AUX_PIDS );

    if( pids==error )
        return error{errortext:="There are no mysql_aux attached! (not connected?)"};
    elseif( pids.size() < 1)
        return error{errortext:="There are no mysql_aux attached! (disconnected?)"};
    endif

    var pid := pids.randomentry();

    var aux_process := GetProcess(pid);

    var ev_to_send := struct;

    ev_to_send.type := "query";

    if( blocking )
        ev_to_send.pid := GetPid();
    else
        ev_to_send.pid := -1;
    endif

    if( TypeOf(s_query)!="Array" )
        ev_to_send.sql := CAscz( s_query );
    else
        ev_to_send.sql := s_query;
    endif

    //print( ev_to_send );

    aux_process.sendevent(ev_to_send);
    
    if( not blocking )
        return 1;
    else
        var ev := wait_for_event(MYSQL_QUERY_TIMEOUT);        
        if( ev or ev==error)
            return ev;
        endif        
    endif

    return error{errortext:="mysql_aux timeout!"};
    
endfunction